| http://www.sim.no/ http://www.coin3d.org/

Public Member Functions | Static Public Member Functions | Public Attributes | Protected Member Functions | Static Protected Member Functions | List of all members
SoCalculator Class Reference
Engine Classes

General purpose calculator for floats and 3D float vectors.The SoCalculator uses the values from the input fields (which are either single floating point values or vectors) as variables in the free-form engine expressions and places the results on the output fields. More...

`#include <Inventor/engines/SoCalculator.h>`

Inheritance diagram for SoCalculator:

## Public Member Functions

virtual SoType | getTypeId (void) const
virtual const SoFieldData * | getFieldData (void) const
virtual const SoEngineOutputData * | getOutputData (void) const
| SoCalculator (void)
Public Member Functions inherited from SoEngine
void | evaluateWrapper (void)
virtual int | getOutputs (SoEngineOutputList &l) const
SoEngineOutput * | getOutput (const SbName &outputname) const
SbBool | getOutputName (const SoEngineOutput *output, SbName &outputname) const
SbBool | isNotifying (void) const
virtual void | notify (SoNotList *nl)
SoEngine * | copy (void) const
virtual SoFieldContainer * | copyThroughConnection (void) const
SbBool | shouldCopy (void) const
virtual void | writeInstance (SoOutput *out)
Public Member Functions inherited from SoFieldContainer
void | setToDefaults (void)
SbBool | hasDefaultValues (void) const
SbBool | fieldsAreEqual (const SoFieldContainer *container) const
void | copyFieldValues (const SoFieldContainer *container, SbBool copyconnections=FALSE)
SbBool | set (const char *const fielddata)
void | get (SbString &fielddata)
virtual int | getFields (SoFieldList &l) const
virtual int | getAllFields (SoFieldList &l) const
virtual SoField * | getField (const SbName &name) const
virtual SoField * | getEventIn (const SbName &name) const
virtual SoField * | getEventOut (const SbName &name) const
SbBool | getFieldName (const SoField *const field, SbName &name) const
SbBool | enableNotify (const SbBool flag)
SbBool | isNotifyEnabled (void) const
SbBool | set (const char *fielddata, SoInput *input)
void | get (SbString &fielddata, SoOutput *out)
virtual SbBool | validateNewFieldValue (SoField *field, void *newval)
virtual void | addWriteReference (SoOutput *out, SbBool isfromfield=FALSE)
SbBool | getIsBuiltIn (void) const
virtual void | copyContents (const SoFieldContainer *from, SbBool copyconnections)
virtual void | getFieldsMemorySize (size_t &managed, size_t &unmanaged) const
void | setUserData (void *userdata) const
void * | getUserData (void) const
Public Member Functions inherited from SoBase
void | ref (void) const
void | unref (void) const
void | unrefNoDelete (void) const
int32_t | getRefCount (void) const
void | touch (void)
SbBool | isOfType (SoType type) const
virtual SbName | getName (void) const
virtual void | setName (const SbName &newname)
virtual void | startNotify (void)
void | addAuditor (void *const auditor, const SoNotRec::Type type)
void | removeAuditor (void *const auditor, const SoNotRec::Type type)
const SoAuditorList & | getAuditors (void) const
SbBool | shouldWrite (void)
void | assertAlive (void) const

## Static Public Member Functions

static SoType | getClassTypeId (void)
static void * | createInstance (void)
static void | initClass (void)
Static Public Member Functions inherited from SoEngine
static void | initClass (void)
static void | initClasses (void)
static SoType | getClassTypeId (void)
static SoEngine * | getByName (const SbName &name)
static int | getByName (const SbName &name, SoEngineList &el)
Static Public Member Functions inherited from SoFieldContainer
static void | initClass (void)
static SoType | getClassTypeId (void)
static void | cleanupClass (void)
static void | initCopyDict (void)
static void | addCopy (const SoFieldContainer *orig, const SoFieldContainer *copy)
static SoFieldContainer * | checkCopy (const SoFieldContainer *orig)
static SoFieldContainer * | findCopy (const SoFieldContainer *orig, const SbBool copyconnections)
static void | copyDone (void)
Static Public Member Functions inherited from SoBase
static void | initClass (void)
static SoType | getClassTypeId (void)
static void | addName (SoBase *const base, const char *const name)
static void | removeName (SoBase *const base, const char *const name)
static void | incrementCurrentWriteCounter (void)
static void | decrementCurrentWriteCounter (void)
static SoBase * | getNamedBase (const SbName &name, SoType type)
static int | getNamedBases (const SbName &name, SoBaseList &baselist, SoType type)
static SbBool | read (SoInput *input, SoBase *&base, SoType expectedtype)
static void | setInstancePrefix (const SbString &c)
static void | setTraceRefs (SbBool trace)
static SbBool | getTraceRefs (void)
static SbBool | connectRoute (SoInput *input, const SbName &fromnodename, const SbName &fromfieldname, const SbName &tonodename, const SbName &tofieldname)
static SbBool | readRoute (SoInput *input)

## Public Attributes

SoMFFloat | a
SoMFFloat | b
SoMFFloat | c
SoMFFloat | d
SoMFFloat | e
SoMFFloat | f
SoMFFloat | g
SoMFFloat | h
SoMFVec3f | A
SoMFVec3f | B
SoMFVec3f | C
SoMFVec3f | D
SoMFVec3f | E
SoMFVec3f | F
SoMFVec3f | G
SoMFVec3f | H
SoMFString | expression
SoEngineOutput | oa
SoEngineOutput | ob
SoEngineOutput | oc
SoEngineOutput | od
SoEngineOutput | oA
SoEngineOutput | oB
SoEngineOutput | oC
SoEngineOutput | oD

## Protected Member Functions

virtual | ~SoCalculator (void)
virtual void | inputChanged (SoField *which)
Protected Member Functions inherited from SoEngine
| SoEngine (void)
virtual | ~SoEngine (void)
virtual SbBool | readInstance (SoInput *in, unsigned short flags)
void | writeOutputTypes (SoOutput *out)
Protected Member Functions inherited from SoFieldContainer
| SoFieldContainer (void)
virtual | ~SoFieldContainer ()
Protected Member Functions inherited from SoBase
| SoBase (void)
virtual | ~SoBase ()
SbBool | hasMultipleWriteRefs (void) const
SbBool | writeHeader (SoOutput *out, SbBool isgroup, SbBool isengine) const
void | writeFooter (SoOutput *out) const
virtual const char * | getFileFormatName (void) const

## Static Protected Member Functions

static const SoFieldData ** | getInputDataPtr (void)
static const SoEngineOutputData ** | getOutputDataPtr (void)
Static Protected Member Functions inherited from SoEngine
static const SoFieldData ** | getInputDataPtr (void)
static const SoEngineOutputData ** | getOutputDataPtr (void)
Static Protected Member Functions inherited from SoBase
static uint32_t | getCurrentWriteCounter (void)
static void | staticDataLock (void)
static void | staticDataUnlock (void)

## Additional Inherited Members

Protected Types inherited from SoBase
enum | BaseFlags { IS_ENGINE = 0x01, IS_GROUP = 0x02 }
Protected Attributes inherited from SoFieldContainer
SbBool | isBuiltIn

## Detailed Description

General purpose calculator for floats and 3D float vectors.

The SoCalculator uses the values from the input fields (which are either single floating point values or vectors) as variables in the free-form engine expressions and places the results on the output fields.

The engine has sixteen input fields; eight scalar inputs (a, b, c, d, e, f g, and h), and eight vector inputs (A, B, C, D, E, F, G, and H).

There are eight output fields; four scalar outputs (oa, ob, oc, and od), and four vector outputs (oA, oB, oC, and oD).

The expression syntax is quite similar to C/C++, with a very limited set of keywords and functions.

An example:

oa = a * (0.5 + b) / c

Will multiply the value in a with the value in b plus 0.5, divide that result with c, and place the result in oa. Since this is an engine, the expression will only be evaluated when someone attempts to read the value in oa, not every time an input in changed.

All inputs are multi-fields, and if there are several values in an input, the expression will be evaluated once for every input field value, and the output will create as many values as there are input field values.

If there is more than one input field, and the input fields do not have the same number of values, the engine will create as many output values as the input field with the biggest number of values. When the index get out of bounds for some other input field, the last field value will be used.

Vector expressions are similar to scalar expression. An example:

oA = A + vec3f(1.0, 0.0, 0.0) * B

Will take the vector in A, add the value in B multiplied with (1,0,0), and place the result in oA.

In addition to regular arithmetics, the SoCalculator syntax also includes some functions.

Scalar functions:

- cos(x) - cosine function (x in radians)
- sin(x) - sinus function
- tan(x) - tangent function
- acos(x) - arc cosine function
- asin(x) - arc sinus function
- atan(x) - arc tangent function
- atan2(y, x) - arc tangent function of two variables (y, x).
- cosh(x) - hyperbolic cosine function
- sinh(x) - hyperbolic sinus function
- tanh(x) - hyperbolic tangent function
- sqrt(x) - square root function
- pow(x,y) - x raised to the power of y
- exp(x) - e to the power of x
- log(x) - natural logarithm of x
- log10() - base-10 logarithm of x
- ceil(x) - rounds x upwards to the nearest integer
- floor(x) - rounds x downwards to the nearest integer
- fabs(x) - absolute value
- fmod(x, y) - remainder of dividing x by y
- rand(x) - pseudo-random value between 0 and 1

Vector functions:

- cross(x, y) - cross product of x and y
- dot(x,y) - dot product of x and y (returns scalar value)
- length(x) - length of x (returns scalar value)
- normalize(x) - returns normalized version of x
- x[y] - access components in x (y should be a scalar value in the range [0,2])

There are also some named constants that can be used:

- MAXFLOAT
- MINFLOAT
- M_E
- M_LOG2E
- M_LOG10E
- M_LN2
- M_PI
- M_SQRT2 - sqrt(2)
- M_SQRT1_2 - sqrt(1/2)

The only control flow available is the ? operator. An example:

oa = (a > b) ? (a * 0.5) : (b * c)

(The parentheses are not necessary, they're there just to make the example easier to read)

In addition to the standard comparators (<, >, <=, >=, ==, !=), you can also use && (AND) and || (OR) to combine expression, and the unary ! (NOT) operator.

One final thing worth mentioning is the temporary variables. There exists sixteen temporary variables that can be used in expressions. ta, tb, tc, td, te, tf, tg, and th are scalar variables, and tA, tB, tC, tD, tE, tF, tG, and tH are vector variables. They are usually used when you have more than one expression that should be evaluated in order.

An example with three expressions:

ta = a * b; tb = c + d; tc = e - f
tA = vec3f(ta, tb, tc) + A
oA = tA * B

The example just shows how temporary variables can be used to make your expressions easier to read. Please note that it's possible to have several statements in one expression. You just separate them with semicolons.

Here is a simple example of how an SoCalculator engine may be used in an .iv file:

DEF mycamera PerspectiveCamera {
orientation 1 0 0 1.57
}
DEF headlight DirectionalLight {
intensity 0.8
direction 0 0 1
}
Separator {
# Render a cube not affected by lighting
LightModel { model BASE_COLOR }
BaseColor { rgb = Calculator {
a = USE headlight . intensity
expression [ "oA = vec3f( a, a, a)" ]
} . oA }
Cube {}
}

In the example, the color of the Cube is a function of the intensity of the DirectionalLight, even though the Cube is rendered without lighting because of the BASE_COLOR LightModel.

## Constructor & Destructor Documentation

## ◆ SoCalculator()

SoCalculator::SoCalculator | ( | void |  | ) |

Constructor.

## ◆ ~SoCalculator()

SoCalculator::~SoCalculator | ( | void |  | ) |

protectedvirtual

Destructor.

## Member Function Documentation

## ◆ getTypeId()

SoType SoCalculator::getTypeId | ( | void |  | ) | const

virtual

Returns the type identification of an object derived from a class inheriting SoBase. This is used for run-time type checking and "downward" casting.

Usage example:

void foo(SoNode * node)
{
if (node->getTypeId() == SoFile::getClassTypeId()) {
SoFile * filenode = (SoFile *)node; // safe downward cast, knows the type
}
}

For application programmers wanting to extend the library with new nodes, engines, nodekits, draggers or others: this method needs to be overridden in all subclasses. This is typically done as part of setting up the full type system for extension classes, which is usually accomplished by using the pre-defined macros available through for instance Inventor/nodes/SoSubNode.h (SO_NODE_INIT_CLASS and SO_NODE_CONSTRUCTOR for node classes), Inventor/engines/SoSubEngine.h (for engine classes) and so on.

For more information on writing Coin extensions, see the class documentation of the toplevel superclasses for the various class groups.

Implements SoBase.

## ◆ getFieldData()

const SoFieldData * SoCalculator::getFieldData | ( | void |  | ) | const

virtual

Returns a pointer to the class-wide field data storage object for this instance. If no fields are present, returns `NULL`.

Reimplemented from SoFieldContainer.

## ◆ getOutputData()

const SoEngineOutputData * SoCalculator::getOutputData | ( | void |  | ) | const

virtual

This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

Implements SoEngine.

## ◆ inputChanged()

void SoCalculator::inputChanged | ( | SoField * | which | ) |

protectedvirtual

Called when an input is changed. The default method does nothing, but subclasses may override this method to do The Right Thing when a specific field is changed.

Reimplemented from SoEngine.

## Member Data Documentation

## ◆ a

SoMFFloat SoCalculator::a

Input floating point value for the expressions.

## ◆ b

SoMFFloat SoCalculator::b

Input floating point value for the expressions.

## ◆ c

SoMFFloat SoCalculator::c

Input floating point value for the expressions.

## ◆ d

SoMFFloat SoCalculator::d

Input floating point value for the expressions.

## ◆ e

SoMFFloat SoCalculator::e

Input floating point value for the expressions.

## ◆ f

SoMFFloat SoCalculator::f

Input floating point value for the expressions.

## ◆ g

SoMFFloat SoCalculator::g

Input floating point value for the expressions.

## ◆ h

SoMFFloat SoCalculator::h

Input floating point value for the expressions.

## ◆ A

SoMFVec3f SoCalculator::A

Input vector with three floating point values for the expressions.

## ◆ B

SoMFVec3f SoCalculator::B

Input vector with three floating point values for the expressions.

## ◆ C

SoMFVec3f SoCalculator::C

Input vector with three floating point values for the expressions.

## ◆ D

SoMFVec3f SoCalculator::D

Input vector with three floating point values for the expressions.

## ◆ E

SoMFVec3f SoCalculator::E

Input vector with three floating point values for the expressions.

## ◆ F

SoMFVec3f SoCalculator::F

Input vector with three floating point values for the expressions.

## ◆ G

SoMFVec3f SoCalculator::G

Input vector with three floating point values for the expressions.

## ◆ H

SoMFVec3f SoCalculator::H

Input vector with three floating point values for the expressions.

## ◆ expression

SoMFString SoCalculator::expression

Mathematical expressions for the calculator.

## ◆ oa

SoEngineOutput SoCalculator::oa

(SoMFFloat) Output value with result from the calculations.

## ◆ ob

SoEngineOutput SoCalculator::ob

(SoMFFloat) Output value with result from the calculations.

## ◆ oc

SoEngineOutput SoCalculator::oc

(SoMFFloat) Output value with result from the calculations.

## ◆ od

SoEngineOutput SoCalculator::od

(SoMFFloat) Output value with result from the calculations.

## ◆ oA

SoEngineOutput SoCalculator::oA

(SoMFVec3f) Output value with result from the calculations.

## ◆ oB

SoEngineOutput SoCalculator::oB

(SoMFVec3f) Output value with result from the calculations.

## ◆ oC

SoEngineOutput SoCalculator::oC

(SoMFVec3f) Output value with result from the calculations.

## ◆ oD

SoEngineOutput SoCalculator::oD

(SoMFVec3f) Output value with result from the calculations.

The documentation for this class was generated from the following files:

- SoCalculator.h
- SoCalculator.cpp

Copyright © 1998-2010 by Kongsberg Oil & Gas Technologies. All rights reserved.